/****
 *
 * Exemplo: Leitura1.c
 *
 * Captulo: 3
 * Seo: 3.7
 *
 * Demonstra: Leitura e validao de dados (verso I).
 *
 ****/

#include <stdio.h>

#define VALOR_TERMINAL  0    /* Esta constante sinaliza o final do programa */

extern long unsigned LeValor(void);
extern unsigned VerificaValor(int valor);
extern void  LimpaBuffer(void);

/****
 *
 * A funo main() l valores e processa valores repetidamente
 * at que um valor que sinaliza o final do programa  lido
 *
 * Substitua o tipo long unsigned pelo tipo de dado dos valores
 * que seu programa processa
 *
 * Se for o caso, substitua o teste "valorLido != VALOR_TERMINAL"
 * pela condio de parada do seu programa
 *
 * Substitua a chamada de printf() por uma chamada da funo
 * que realiza o processamento dos valores lidos
 *
 ****/

int main(void)
{
   long unsigned valorLido;

   valorLido = LeValor();

   while(valorLido != VALOR_TERMINAL) {
      printf("\nO valor lido foi: %ld\n", valorLido);
      valorLido = LeValor();
   }

   return 0;
}

/****
 *
 * A funo LeValor() l valores no meio de entrada padro
 * e retorna apenas aqueles que realmente satisfazem os
 * critrios do programa
 *
 * Substitua convenientemente as indicaes (prompts) apresentadas
 * pelas chamadas de printf() para se adequarem ao seu programa
 *
 * Substitua convenientemente o tipo da varivel local valor
 *
 * Substitua convenientemente o especificador de formato "%d"
 * utilizado nas chamadas das funes scanf() e printf()
 *
 * NOTA: Os comentrios apresentados aqui so meramente didticos e voc
 * 		pode remov-los, j que o funcionamento da funo  bvio.
 *
 ****/

long unsigned LeValor(void)
{
   long     valor;   /* Substitua long pelo tipo conveniente */
   unsigned teste;

   printf("\nIntroduza um numero inteiro positivo: ");  /* Substitua pelo prompt conveniente */
   teste = scanf("%ld", &valor);   /* Substitua %d pelo especificador conveniente */

   while (!teste || !VerificaValor(valor)) {
      if (teste) {  /* O valor  do tipo especificado na chamada de scanf(),  */
                    /* mas no satisfaz os critrio do programa */
         printf("\nO valor %ld nao e' valido", valor);   /* Substitua %ld adequadamente */
      } else { /* O valor NO  do tipo especificado na chamada de scanf() e */
         	   /* nada foi lido */
         printf("\nO valor introduzido nao e' valido");
      } /* if */

      printf("\nIntroduza um numero inteiro positivo: "); /* Talvez o programa deva   */
                                                          /* apresentar um prompt     */
                                                          /* mais elaborado desta vez */
      LimpaBuffer();  /*  necessrio limpar o buffer de entrada */
                      /* antes de fazer uma nova leitura */

      teste = scanf("%ld", &valor);  /* Tenta nova leitura */
   }

   LimpaBuffer();  /* Limpa o buffer de entrada antes de retornar 	*/
                   /* Assim, a prxima leitura ser novinha em folha */

   return valor;   /* Se a execuo saiu do lao while, o ltimo      */
                   /* valor lido satisfaz os critrios especificados. */
                   /* Simplesmente retorne este valor                 */
}

/****
 *
 * A funo VerificaValor() verifica se o argumento recebido satisfaz
 * os critrios do programa. Se este for o caso, ela retorna 1; caso
 * contrrio, ela retorna 0.
 *
 * Se o critrio for to simples como o apresentado aqui (valor >= 0), voc
 * no precisa desta funo. Simplesmente, substitua a chamada
 * VerificaValor(valor) na funo LeValor() pelo teste adequado. Caso contrrio,
 * substitua a expresso pelos testes que verificam a adequao do valor.
 *
 ****/

unsigned VerificaValor(int valor)
{
   return (valor >= 0);
}


/****
 *
 * A funo LimpaBuffer() l e descarta todos os caracteres que porventura
 * tenham sido deixados no buffer de entrada na tentativa de leitura de dados
 *
 * Voc no precisa modificar esta funo nem deve utilizar fflush() para
 * descarregar o buffer de entrada. A funo fflush() serve apenas para
 * bufffers de sada.
 *
 ****/

void LimpaBuffer(void)
{
   scanf("%*[^\n]");
   (void) getchar();
}

