/****
 *
 * Exemplo: va_arg1.c
 *
 * Captulo: 3
 * Seo: 3.4
 *
 * Demonstra: Funes com listas de argumentos variveis.
 *
 ****/

#include <stdio.h>
#include <stdarg.h>

int SomaComArgumentosVariveis(int arg1, ...)
{
   int     	soma = arg1;
   va_list 	argumentos;
   int 		umArgumento;

   va_start(argumentos, arg1); 	/* Inicializa lista de  */
                                /* argumentos variveis */

			/* L cada argumento e acrescenta  soma      */
			/* O valor 0 encerra o processamento da lista */
   while ((umArgumento = va_arg(argumentos, int)) != 0) {
      soma += umArgumento;
   }

   va_end(argumentos);	/* Encerra o processamento dos argumentos */

   return soma;
}

int main(void)
{
   printf( "A soma de 1+2+3+4 e': %d\n",
           SomaComArgumentosVariveis(1,2,3,4,0) );

   return 0;
}
