/****
 *
 * Exemplo: MacroTroca.c
 *
 * Captulo: 5
 * Seo: 5.3
 *
 * Demonstra: O uso de macro tendo um tipo como argumento.
 *
 ****/

#include <stdio.h>

#define TROCA(tipo, x, y) do { tipo tmp = x; x = y; y = tmp; } while (0)

#define IMPRIME(x, f) printf("\nValor de %s = %" #f, #x, x)

int main(void)
{
   int 	i = 10, j = -5;
   float	x = 3.14f, y = 1.6f;

   printf("\nAntes de trocar:");
   IMPRIME(x, f);
   IMPRIME(y, f);

   TROCA(float, x, y);

   printf("\n\nDepois de trocar:");
   IMPRIME(x, f);
   IMPRIME(y, f);

   printf("\n\nAntes de trocar:");
   IMPRIME(i, d);
   IMPRIME(j, d);

   TROCA(int, i, j);

   printf("\n\nDepois de trocar:");
   IMPRIME(i, d);
   IMPRIME(j, d);

   return 0;
}
