/****
 *
 * Exemplo: Bubble2.c
 *
 * Captulo: 10
 * Seo: 10.8.2
 *
 * Demonstra: Generalizao da implementao do mtodo
 *            da bolha usando ponteiros para funes.
 *
 ****/

#include <stdio.h>

#define  FALSE  0
#define  TRUE   1

int   ComparaCrescente(int   a, int  b)
{
    return (a > b);
}

int   ComparaDecrescente(int   a, int  b)
{
    return (a < b);
}

void BubbleSort2( int lista[], unsigned  int  tamanhoDaLista,
                  int  (*Compara)(int, int) )
{
   unsigned  i, ordenada = FALSE;
   int 	 aux;

   while (!ordenada){
      ordenada = TRUE;	/* Supe que a lista est ordenada */

     	for (i = 0; i < tamanhoDaLista - 1; i++){
	 if (Compara(lista[i], lista[i+1])){/* Compara elementos vizinhos*/
	   ordenada = FALSE; /* Pelo menos um elemento fora de ordem */

			/* Troca elementos adjacentes */
	   aux = lista[i];
	   lista[i] = lista[i+1];
	   lista[i+1] = aux;
	 }  /* final do if */
      } /* final do for */
   } /* final do while */
} /* final da funo BubbleSort */


int main(void)
{
   int  arrayDeInts[] = {12, 55, 21, 1, 6, 8, 17, 220, 5, 83};
   int  i, tamanhoAr;

   tamanhoAr = sizeof(arrayDeInts)/sizeof(arrayDeInts[0]);

   printf("Ordem original:\n");
   for (i=0; i < tamanhoAr; i++) {
     printf(" %d ", arrayDeInts[i]);
   }

   BubbleSort2(arrayDeInts, tamanhoAr, ComparaCrescente);

   printf("\n\nOrdem crescente:\n");
   for (i=0; i < tamanhoAr; i++) {
     printf(" %d ", arrayDeInts[i]);
   }

   BubbleSort2(arrayDeInts, tamanhoAr, ComparaDecrescente);

   printf("\n\nOrdem decrescente:\n");
   for (i=0; i < tamanhoAr; i++) {
     printf(" %d ", arrayDeInts[i]);
   }

   return 0;
}

