/****
 *
 * Ttulo: Leitura e Validao de Dados II (Seo 10.9)
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 04/07/2002
 * ltima modificao: 07/07/2002
 *
 * Descrio Geral: Este programa demonstra a leitura e validao de
 *					valores do tipo double introduzidos pelo usurio.
 *
 * Entrada: Valores do tipo double seguindo critrios especificados
 *
 * Sada: Quando o valor introduzido pelo usurio  vlido, este valor 
 *			 impresso conforme interpretao do programa. Quando o valor
 *			 introduzido  invlido, imprime uma mensagem de erro indicando
 *			 a causa do erro.
 *
 ****/

#include <stdio.h>
#include "Leitura2.h"

#define VALOR_TERMINAL  0.0    /* Esta constante sinaliza o final da */
                               /* primeira parte do programa         */

#define MAXIMO_DE_VALORES  3  /* Esta constante indica o nmero mximo         */
                              /* de valores lidos na segunda parte do programa */

/****
 *
 * A funo VerificaValor1() verifica se o argumento recebido satisfaz
 * critrios de validade do programa. Esta funo  usada na primeira parte
 * da demonstrao.
 *
 * Argumento (entrada): valor - o valor do tipo double a ser verificado.
 *
 * Retorno: 1, se valor >= 0; 0, em caso contrrio.
 *
 ****/

static unsigned VerificaValor1(double valor)
{
   return (valor >= 0.0);
}

/****
 *
 * A funo VerificaValor2() verifica se o argumento recebido satisfaz
 * critrios de validade do programa. Esta funo  usada na segunda parte
 * da demonstrao.
 *
 * Argumento (entrada): valor - o valor do tipo double a ser verificado.
 *
 * Retorno: 1, se valor >= 10.0 e valor < 20.0; 0, em caso contrrio.
 *
 ****/

static unsigned VerificaValor2(double valor)
{
	return ((valor >= 10.0) && (valor < 20.0));
}

/****
 *
 * A funo main() demonstra a leitura e validao de valores.
 * Esta demonstrao  dividida em duas partes:
 *		(1) Na primeira parte, so lidos e validados valores double at que
 *			 o valor 0.0  introduzido. A validao  feita utilizando a funo
 *			 VerificaValor1().
 *		(2) Na segunda parte, so lidos e validados trs valores double entre
 *			 10.0 (inclusive) e 20.0. A validao  feita utilizando a funo
 *			 VerificaValor2()
 *
 ****/

int main(void)
{
   double   valorLido;    /* Armazena os valores lidos */
   unsigned teste; 		  /* Armazena o valor retornado pela funo LeValor() */
   int  		nValoresLidos = 0;   /* Armazena o nmero de valores vlidos */
   									 /* na segunda parte do programa abaixo  */

   printf("\t** Este programa demonstra uma tecnica de leitura e validacao **\n\n");

   printf("Esta parte do programa aceita apenas valores de ponto-flutuante "
   		  "positivos ou zero. Ela encerra quando 0.0 e' lido.\n\n");

   teste = LeValor(&valorLido, VerificaValor1);  /* Tenta ler o primeiro valor */

   while(1) {  /* Este lao termina com break no seu interior */
      if (teste) {   /* Valor lido est ok? */
         if (valorLido != VALOR_TERMINAL)                   /* Simplesmente,   */
            printf("\nO valor lido foi: %lf\n", valorLido); /* imprime o valor */
         else     /* O valor lido  igual ao valor que termina o lao */
            break;    /* Tchau while */
      }
      teste = LeValor(&valorLido, VerificaValor1);  /* Tenta ler o prximo valor */
   }

   printf("\n**************************************************************\n");
   printf("\nEsta parte do programa aceita valores de ponto-flutuante \n"
   		  "entre 10 (inclusive) e 20. \nNo maximo tres valores sao lidos.\n\n");

   do {
      teste = LeValor(&valorLido, VerificaValor2);
      if (teste) {    /* Valor lido est ok? */
         ++nValoresLidos;  /* Leva em conta apenas os valores vlidos */
         printf("\nO valor lido foi: %lf\n", valorLido); /* Apenas imprime o valor */
      }
   } while(nValoresLidos < MAXIMO_DE_VALORES);

   printf("\n**************************************************************\n");
   printf("\nPrograma encerrado. Bye, bye.");

   return 0;
}


