/****
 *
 * Exemplo: MacroFREE.c
 *
 * Captulo: 11
 * Seo: 11.2.4
 *
 * Demonstra: Definio e uso da macro FREE, que  mais
 *            recomendvel do que o uso da funo free().
 *
 ****/

#include <stdio.h>
#include <stdlib.h>

   /*  sempre recomendvel atribuir NULL a um ponteiro */
   /* aps a liberao do espao apontado pelo ponteiro */
   /* O uso de do {} while(0)  um artifcio utilizado  */
   /* para encapsular vrias instrues numa nica      */

#define FREE(P) do {free(P); P = NULL;} while(0)

int main(void)
{
   double *p;

   p = calloc(2, sizeof(double));

   if (p) { /* Numa situao real o bloco seria processado ... */
      printf("\nO ponteiro foi alocado");
      FREE(p); /* e liberado quando no fosse mais preciso */
   } else {
      printf("\nAlocacao nao foi possivel");
   }

        /* Se o comentrio a seguir for removido, */
        /* ocorrer um erro em tempo de execuo  */
/*   *p = 3.5; */

   if (!p)
       printf("\nTentativa de acesso a bloco nao alocado");

   return 0;
}
