/****
 *
 * Exemplo: MinhaCalloc.c
 *
 * Captulo: 11
 * Seo: 11.2.2
 *
 * Demonstra: Implementao da funo calloc().
 *
 ****/

#include <stdio.h>
#include <stdlib.h>

void *MinhaCalloc(size_t nBlocos, size_t tamanho)
{
   unsigned long i, nBytes = nBlocos*tamanho;
   char          *ptr = malloc(nBytes);

   if (!ptr) /* No foi possvel alocar o espao solicitado */
      return NULL;

      /* Aqui, o espao j foi alocado */
      /* Resta apenas zerar os bytes   */
   for (i = 0; i < nBytes; ++i)
      ptr[i] = 0; /* Zera cada byte */

   return ptr; /* Trabalho completo */
}

int main(void)
{
   double *p;

   p = MinhaCalloc(2, sizeof(double));

   if (p) {
      printf("\np[0] = %lf \t p[1] = %lf", p[0], p[1]);

      p[0] = 3.14;
      p[1] = 2.54;

      printf("\np[0] = %lf \t p[1] = %lf", p[0], p[1]);
   } else {
      printf("\nAlocacao nao foi possivel");
   }

   return 0;
}
