/****
 *
 * Exemplo: Modos.c
 *
 * Captulo: 12
 * Seo: 12.8.1
 *
 * Demonstra: A funo fwrite() funciona de maneiras
 *            diferentes dependendo do modo de abertura
 *            do arquivo (texto ou binrio).
 *
 ****/

#include <stdio.h>

int main(void)
{
   FILE *streamSaida; /* Stream de sada */
   char  c = '\n';

   streamSaida = fopen("ModoTexto.txt", "w"); /* Modo texto */

           /*** Trecho 1 ***/

   if (!streamSaida)
      return 1;	/* Arquivo no pode ser aberto */

   for (int i = 0; i < 100; ++i)
      fwrite(&c, 1, 1, streamSaida);

   fclose(streamSaida);

           /*** Trecho 2 ***/

   streamSaida = fopen("ModoBin.txt", "wb"); /* Modo binrio */

   if (!streamSaida)
      return 1;	/* Arquivo no pode ser aberto */

   for (int i = 0; i < 100; ++i)
      fwrite(&c, 1, 1, streamSaida);

   fclose(streamSaida);

   getchar();
   return 0;
}
