/****
 *
 * Exemplo: TamArquivo.c
 *
 * Captulo: 12
 * Seo: 12.9
 *
 * Demonstra: O uso das funes fseek() e ftell().
 *
 ****/

#include <stdio.h>

#define NOME_DO_ARQUIVO "Teste.txt"

long TamanhoDeArquivo(FILE *stream)
{
   long posicaoAtual, tamanho;

      /* Guarda a posio atual do apontador de posio do arquivo */
   posicaoAtual = ftell(stream);

   fseek(stream, 0L, SEEK_END);  /* Vai para o final do arquivo */
   tamanho = ftell(stream); /* Nmero de bytes do incio at o fim */

      /* Restaura a posio original do apontador de posio */
   fseek(stream, posicaoAtual, SEEK_SET);

   return tamanho;
}

int main(void)
{
   FILE *stream;
   const char *strArquivo = NOME_DO_ARQUIVO;

   stream = fopen(strArquivo, "w+"); /* Arquivo deve ser aberto em modo binrio! */

   if (!stream)
      return 1; /* Arquivo no pode ser aberto */

   printf("O apontador de arquivo esta' na posicao: "
          "%ld\n", ftell(stream));

   fprintf(stream, "Isto e' um teste.");

   printf("Agora, o apontador de arquivo esta' na posicao: "
          "%ld\n", ftell(stream));

   printf("\nTamanho do arquivo %s em bytes: %ld",
           strArquivo, TamanhoDeArquivo(stream));

   fclose(stream);

   return 0;
}
