/****
 *
 * Exemplo: vsnprintf.c
 *
 * Captulo: 12
 * Seo: 12.10.3
 *
 * Demonstra: O uso da funo vsnprintf().
 *
 ****/

#include <stdio.h>
#include <stdarg.h>

#define MAX 80

int ExemploDe_vsnprintf( char *s, size_t n,
                         const char *formato, ... )
{
   va_list  argumentos;
   int      retorno;

   va_start(argumentos, formato);
   retorno = vsnprintf(s, n, formato, argumentos);
   va_end(argumentos);

   return retorno;
}

int main(void)
{
   char    ar[MAX];
   int     umInt = 32, nCarEscritos = 0;
   double  umDouble = 6.35;
   char   *umString = "bola";
   char    umChar = 'X';
   char   *formato;

   formato = "umInt = %d, umDouble = %lf, umString = %s, "
             "umChar = %c";

   nCarEscritos = ExemploDe_vsnprintf( ar, MAX, formato, umInt,
                                       umDouble, umString, umChar );

   printf( "String:\n\t%s \n\nNumero de caracteres escritos no array:"
           " %d\n", ar, nCarEscritos );

   return 0;
}
