/****
 *
 * Exemplo: vsprintf.c
 *
 * Captulo: 12
 * Seo: 12.10.3
 *
 * Demonstra: O uso da funo vsprintf().
 *
 ****/

#include <stdio.h>
#include <stdarg.h>

int ExemploDe_vsprintf(char *ar, const char *formato, ...)
{
   va_list argumentos;
   int     retorno;

      /* Acessa a lista de argumentos variveis representada por */
      /* "..." usando uma varivel do tipo va_list e chama a     */
      /* funo vsprintf() passando esta varivel como argumento */
   va_start(argumentos, formato);
   retorno = vsprintf(ar, formato, argumentos);
   va_end(argumentos);

   return retorno;
}

int main(void)
{
   int    umInteiro = 33;
   float  umFloat = 44.5;
   char   umString[20] = "Isto e' um teste";
   char   array[80] = "Isto e' um teste";

   ExemploDe_vsprintf( array, "%d %f %s",
                       umInteiro, umFloat, umString );
   printf("Conteudo do array: %s\n", array);

   return 0;
}
