/****
 *
 * Exemplo: ReprBinaria.c
 *
 * Captulo: 13
 * Seo: 13.5
 *
 * Demonstra: Representao interna de valores inteiros.
 *
 ****/

#include <limits.h>
#include <stdio.h>

/****
 *
 * Funo RepresentacaoBinaria()
 *
 * Descrio:Apresenta no meio de sada a representao binria
 *           de um valor do tipo int.
 *
 * Parmetros:
 *      numero (entrada): valor inteiro cuja representao
 *                        binria ser apresentada
 *
 * Retorno: Nada.
 *
 ****/

void   RepresentacaoBinaria(int  numero)
{
   int           i, bit, numeroDeBits;
   unsigned int  mascara; /* A mscara deve ser unsigned aqui */

       /* Cada byte contm um nmero de bits igual a CHAR_BIT */
   numeroDeBits  = CHAR_BIT*sizeof(int);

       /* Coloca 1 na posio mais  esquerda da  */
       /* mscara. Todos os outros bits tero 0s. */
   mascara = 0x1 << (numeroDeBits - 1);

     /* Imprime cada bit a partir da esquerda do nmero (parmetro) */
   for (i = 1; i <= numeroDeBits; i++) {
      bit = (numero & mascara) ? 1 : 0;
      printf("%d", bit);
      if (i % 4 == 0)   /* Separa bits em seqncias de quatro para */
         printf("   ");	/* melhor visualizao da representao     */

      mascara >>= 1;  /* Move bit com valor 1 da mscara */
                      /*  uma posio para a direita     */
   }
}

int main(void)
{
   int 	 x, teste;
   char  descarta;

   while (1) {
      printf("\nIntroduza um valor inteiro para ver sua representacao: ");
      teste = scanf("%d%c", &x, &descarta);
      if (teste) {
         printf("\nRepresentacao binria de %d:\n", x);
         RepresentacaoBinaria(x);
      } else {
         printf("\nValor invalido. Tchau.");
         break;
      }
   }

   return 0;
}

